package be.jeffcheasey88.peeratcode.parser;

import java.io.BufferedReader;
import java.util.LinkedList;
import java.util.List;

public interface ElementBuilder{
	
	void build(Builder builder) throws Exception;

	public static class Builder{
		
		private List<Token> tokens;
		
		public Builder(){
			this.tokens = new LinkedList<>();
			this.tokens.add(new Token(1,1,"", TokenType.GROUP));
		}
		
		public void append(Token token){
			this.tokens.add(token);
		}
		
		public void append(String value){
			Token last = tokens.get(tokens.size()-1);
			append(new Token(last.getLineNumber(), last.getCharacterNumber()+last.getValue().length(), value, TokenType.GROUP));
		}
	
		public void build(BufferedReader writer) throws Exception{
			
		}
	}
}